# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

import dns.exception as dns
NOERROR = 0
FORMERR = 1
SERVFAIL = 2
NXDOMAIN = 3
NOTIMP = 4
REFUSED = 5
YXDOMAIN = 6
YXRRSET = 7
NXRRSET = 8
NOTAUTH = 9
NOTZONE = 10
BADVERS = 16
_by_text = {
    'NOERROR': NOERROR,
    'FORMERR': FORMERR,
    'SERVFAIL': SERVFAIL,
    'NXDOMAIN': NXDOMAIN,
    'NOTIMP': NOTIMP,
    'REFUSED': REFUSED,
    'YXDOMAIN': YXDOMAIN,
    'YXRRSET': YXRRSET,
    'NXRRSET': NXRRSET,
    'NOTAUTH': NOTAUTH,
    'NOTZONE': NOTZONE,
    'BADVERS': BADVERS }
_by_value = []([ (y, x) for x, y in _by_text.iteritems() ])

class UnknownRcode(dns.exception.DNSException):
    pass


def from_text(text):
    if text.isdigit():
        v = int(text)
        if v >= 0 and v <= 4095:
            return v
        
    
    v = _by_text.get(text.upper())
    if v is None:
        raise UnknownRcode
    
    return v


def from_flags(flags, ednsflags):
    value = flags & 15 | ednsflags >> 20 & 4080
    if value < 0 or value > 4095:
        raise ValueError, 'rcode must be >= 0 and <= 4095'
    
    return value


def to_flags(value):
    if value < 0 or value > 4095:
        raise ValueError, 'rcode must be >= 0 and <= 4095'
    
    v = value & 15
    ev = long(value & 4080) << 20
    return (v, ev)


def to_text(value):
    text = _by_value.get(value)
    if text is None:
        text = str(value)
    
    return text

